#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <nvault>
#include <nvault_util>
#include <nvault_array>

#pragma dynamic 32768

#define PLUGIN  "Cabeca de BOI de GRATIS HAHAHA"
#define VERSION "1.0"
#define AUTHOR  "Nao interessa HAHAHAAH"

#define OX_HEAD "models/boiCorno.mdl"

new iModelHead[MAX_PLAYERS + 1]
new szAuthid[MAX_PLAYERS + 1][MAX_AUTHID_LENGTH]
new bool:AlreadyOX[MAX_PLAYERS + 1]

const Max_Player_Support = 7000
new g_Vault2
new g_Vault

enum _:RankInfo
{
        nVault_Offset,
        XP_Value
}

new g_SortData[ Max_Player_Support ][ RankInfo ]

enum ( <<=1 )
{
        OxHead = 1
}

new g_Options[MAX_PLAYERS + 1]

#define HasHEAD(%1,%2)    g_Options[%1]&%2
#define AddHEAD(%1,%2)    g_Options[%1]|=%2
#define RemoveHEAD(%1,%2)    g_Options[%1]&=~%2

new const VaultName[] = "OX_INDEX"
new const VaultName2[] = "Top15_boi"

enum TopData
{
        KilledTimes,
        KillTimes,
        PlayerName[MAX_NAME_LENGTH]
}

new eData[MAX_PLAYERS + 1][TopData]

public plugin_init()
{
        register_plugin(PLUGIN, VERSION, AUTHOR)

        register_event("DeathMsg", "DeathMsg", "a", "4=knife")
        RegisterHamPlayer(Ham_Spawn, "PlayerSpawn", true)
        register_clcmd("say /boi", "Top15Boi")
        register_clcmd("say_team /boi", "Top15Boi")
        register_clcmd("say /boi_resetar", "ResetTop15")
        register_clcmd("say_team /boi_resetar", "ResetTop15")

        if ((g_Vault = nvault_open( VaultName )) == INVALID_HANDLE)
        {
                set_fail_state( "Failed to open vault" );
        }

        if ((g_Vault2 = nvault_open( VaultName2 )) == INVALID_HANDLE)
        {
                set_fail_state( "Failed to open vault" );
        }
}

public plugin_precache()
{
        precache_model(OX_HEAD)
}

public PlayerSpawn(id)
{
        if(is_user_alive(id) && HasHEAD(id, OxHead))
                 make_character(id)
}

public DeathMsg()
{
        static Attacker, Victim

        Attacker = read_data(1)
        Victim = read_data(2)

        if(!is_user_connected(Attacker) || !is_user_connected(Victim) || Attacker == Victim)
                return PLUGIN_HANDLED

        make_character(Victim)
        eData[Victim][KilledTimes]++
        save_top15(Victim)

        if(HasHEAD(Attacker, OxHead))
        {
                reset_character(Attacker)
                client_print_color(Attacker, print_team_default, "Voce matou^4 %n^1 na faca e não é mais um boi HAHAHA.", Victim)
        }

        return PLUGIN_HANDLED
}

make_character(id)
{
        if(!AlreadyOX[id])
        {
                iModelHead[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))

                set_pev(iModelHead[id], pev_movetype, MOVETYPE_FOLLOW)
                set_pev(iModelHead[id], pev_aiment, id)
                set_pev(iModelHead[id], pev_rendermode, kRenderNormal)
                engfunc(EngFunc_SetModel, iModelHead[id], OX_HEAD)
                set_pev(iModelHead[id], pev_body, 0)
                set_pev(iModelHead[id], pev_sequence, 0)
                set_pev(iModelHead[id], pev_animtime, get_gametime())
                set_pev(iModelHead[id], pev_framerate, 1.0)
                AddHEAD(id, OxHead)
                AlreadyOX[id] = true

                set_dhudmessage(0, 255, 0, -1.0, 0.3, .effects = 0, .fxtime = 0.0, .holdtime = 3.0, .fadeintime = 0.1, .fadeouttime = 0.2)
                show_dhudmessage(0, "%n morreu na faca e agora é um boi HAHAHA", id)
        }
}

public save_top15(id)
{
        get_user_name(id, eData[id][PlayerName], charsmax(eData[][PlayerName]))

        nvault_set_array(g_Vault2, szAuthid[id], eData[id][TopData:0], sizeof(eData[]))
}

public load_top15(id)
{
        nvault_get_array(g_Vault2, szAuthid[id], eData[ id ][TopData:0], sizeof(eData[]))
}

public client_authorized(id)
{
        get_user_authid(id, szAuthid[id], charsmax(szAuthid[]))
        RemoveHEAD(id, OxHead)
        AlreadyOX[id] = false
        iModelHead[id] = 0
        eData[id][KilledTimes] = 0
        eData[id][KillTimes] = 0
        load_top15(id)
        LoadOX(id)
}

reset_character(id)
{
        set_pev(iModelHead[id], pev_effects, pev(iModelHead[id], pev_effects) | EF_NODRAW)
        iModelHead[id] = 0
        RemoveHEAD(id, OxHead)
        AlreadyOX[id] = false
        eData[id][KillTimes]++
        save_top15(id)
}

public client_disconnected(id, bool:drop, message[], maxlen)
{
        saveOX(id)
        save_top15(id)
        RemoveHEAD(id, OxHead)
        AlreadyOX[id] = false
        iModelHead[id] = 0
        eData[id][KilledTimes] = 0
        eData[id][KillTimes] = 0
}

public LoadOX(id)
{
        g_Options[id] = nvault_get(g_Vault , szAuthid[id])
}

public saveOX(id)
{
        new szData[15]
        num_to_str(g_Options[id] , szData , charsmax(szData))
        nvault_set(g_Vault, szAuthid[id] , szData)
}

public plugin_end()
{
        nvault_close(g_Vault)
        nvault_close(g_Vault2)
}

public Top15Boi(id)
{
        new iVault, iAvailablePlayers, pdVal[ TopData ], iCount, iCurrentOffset, szKey[MAX_PLAYERS + 2]

        iCount = LoadAndSortData(iVault)

        new iLen, xMotd[MAX_MOTD_LENGTH]

        iLen = formatex(xMotd, charsmax(xMotd), "<html><head><title>Motd server</title><style type=^"text/css^"><!--body {margin-left: 0px;margin-top: 0px;margin-right: 0px;margin-bottom: 0px;background-color: #000000;}--></style></head><body><img src=^"https://i.imgur.com/8qyqhZE.jpg^" width=100%% height=35%% border=^"0^" align=^"center^"></body></html>")

        iLen += formatex(xMotd[iLen], charsmax(xMotd)-iLen, "<meta charset=UTF-8>\
        <style>*{margin:0px;}body{color:#fff;background:url(^"https://i.imgur.com/kG7ptt2.jpg^")}table{border-collapse:collapse;border: 1px solid #6d6767;text-align:center;}</style>\
        <body><table width=100%% height=20%% border=1><tr bgcolor=#111010 style=^"color:#fff;^"><th width=5%%>Pos.<th width=35%%>Nick<th width=30%%>Kills<th width=30%%>Mortes")

        iAvailablePlayers = min( iCount , 15 )

        for ( new iRow = 0; iRow < iAvailablePlayers; iRow++)
        {
                iCurrentOffset = g_SortData[iRow][nVault_Offset]

                nvault_util_read_array( iVault , iCurrentOffset , szKey , charsmax(szKey) , pdVal[TopData:0] , sizeof(pdVal))

                iLen += formatex(xMotd[iLen], charsmax(xMotd) - iLen, "<tr><td>%i<td>%s<td>%i<td>%i", iRow + 1, pdVal[PlayerName], pdVal[KillTimes], pdVal[KilledTimes])
        }

        nvault_util_close(iVault)

        show_motd(id, xMotd, "TOP 15 GADO")

        return PLUGIN_HANDLED
}

public LoadAndSortData( &iVault )
{
        new iRow , iCount , iNextOffset , iCurrentOffset , szKey[ 45 ] , pdVal[ TopData ]

        nvault_close( g_Vault2 );
        g_Vault2 = nvault_open( VaultName2 );

        iVault = nvault_util_open( VaultName2 );

        iCount = nvault_util_count( iVault );

        for ( iRow = 0 ; iRow < iCount && iRow < Max_Player_Support ; iRow++ )
        {
                iNextOffset = nvault_util_read_array( iVault , iNextOffset , szKey , charsmax( szKey ) , pdVal[ TopData:0 ] , sizeof( pdVal ) );

                g_SortData[ iRow ][ nVault_Offset ] = iCurrentOffset;

                g_SortData[ iRow ][ XP_Value ] = (pdVal[KillTimes] - pdVal[KilledTimes])

                iCurrentOffset = iNextOffset;
        }

        SortCustom2D( g_SortData , min( iCount , Max_Player_Support ) , "CompareXP" );

        return iCount;
}

public CompareXP(elem1[] , elem2[])
{
        if ( elem1[1] > elem2[1])
                return -1

        else if(elem1[1] < elem2[1])
                return 1

        return 0
}

public ResetTop15(id)
{
        if(!(get_user_flags(id) & ADMIN_CFG))
        {
                console_print(id, "Voce nao tem acesso a este comando!")
                return PLUGIN_HANDLED
        }

        nvault_prune(g_Vault2, 0, get_systime() + 1)

        new id2
        for(id2 = 1; id2 <= MaxClients; id2++)
        {
                eData[id2][KilledTimes] = 0
                eData[id2][KillTimes] = 0
        }

        console_print(id, "***********************************")
        console_print(id, "-> TOP15 BOI ZERADO !!!")
        console_print(id, "***********************************")

        return PLUGIN_HANDLED
}
